#!/bin/bash
#
#
########################################################################
#
# Firewall rules created by <%= $0 %> 
#
########################################################################

#
# exit nicely.
#
set -e

% if $DEBUG
#
# Be verbose
#
set -x
% end

#
# Make sure we have /sbin on our path
#
export PATH=$PATH:/usr/local/sbin:/usr/sbin:/sbin

#
# If we don't have a module-aware kernel we're out of luck.
#
if [ -x "/sbin/modprobe" -a -e "/proc/modules" ] ; then
  for i in iptable_filter nf_conntrack nf_conntrack_ftp ; do
    /sbin/modprobe $i 2> /dev/null
  done
fi

#######################################################################
#
# Clean up existing tables
#
#######################################################################

# TODO: try and iterate through an array, rather than hard-coding it all :)
# declare -a table_filters
# table_filters=("filter INPUT FORWARD OUTPUT" \
#               "nat PREROUTING INPUT OUTPUT POSTROUTING" \
#               "raw PREROUTING OUTPUT")

for cmd in <%= iptables_cmds.join(" ") %> ; do

  #
  # Fix policies
  #
  for chain in INPUT FORWARD OUTPUT ; do
    $cmd -P $chain ACCEPT
  done

  for chain in PREROUTING OUTPUT ; do
    $cmd -t raw -P $chain ACCEPT
  done

  has_nat=""
  if $cmd -t nat -L > /dev/null 2> /dev/null ;  then
    has_nat="1"
  fi

  #
  # nat table only exists for iptables (not ip6tables)
  #
  if [ -n "$has_nat" ] ; then
    for chain in PREROUTING INPUT OUTPUT POSTROUTING ; do
      $cmd -t nat -P $chain ACCEPT
    done
  fi

  #
  # Flush everything
  #
  $cmd -F
  $cmd -t raw -F
  if [ -n "$has_nat" ] ; then
    $cmd -t nat -F
  fi

  #
  # Delete old chains
  #
  $cmd -X
  $cmd -t raw -X
  if [ -n "$has_nat" ] ; then
    $cmd -t nat -X
  fi

  #
  # Allow everythink on loopback
  #
  $cmd -I INPUT  -i lo -j ACCEPT
  $cmd -I OUTPUT -o lo -j ACCEPT
done
#######################################################################


#######################################################################
# 
# Create black/whitelist rules
#
% %w(whitelist blacklist).each do |chain|
%   dir  = File.join(base_dir, "#{chain}.d")
%   disabled = (!File.directory?(dir) or  File.exist?(File.join(dir,"disabled.#{chain}")) or File.exist?(File.join(dir,"disabled")))
#######################################################################
for cmd in <%= iptables_cmds.join(" ") %> ; do
  #
  # See if the chain exists, create if not.
  #
  $cmd -n -L <%= chain %> > /dev/null 2>&1 || $cmd -N <%= chain%> 

  # 
  # Flush the chain, just in case it already existed.
  #
  $cmd -F <%= chain %> 
done

%   if ! disabled
%     list = IPListDirectory.new(dir, "incoming", chain)
%     list.default = chain
<%=   list.to_s %>
%   end
#
# Add the jump in
#
for cmd in <%= iptables_cmds.join(" ") %> ; do
  $cmd -A INPUT -j <%= chain %> 
done

% end


#######################################################################
#
# Add incoming and outgoing rules
#
% %w(incoming outgoing).each do |direction|
#######################################################################
%  dir  = File.join(base_dir, "#{direction}.d")
%  next unless File.directory?(dir) 
%  list = TemplateDirectory.new(dir, direction )
<%= list.to_s %>

% end

% dir = File.join(base_dir, "local.d")
#######################################################################
# Run scripts in local.d
#
if [ -d <%= dir %> ] ; then
  /bin/run-parts <%= $VERBOSELOCAL ? "--verbose" : "" %> --exit-on-error <%= dir %>
fi
#######################################################################


